// Parse a string out of an element.
function ui_parse_string_from_element(e, d)
{
    var celm = document.getElementById(e);
    if (! celm) return d;
    var n = celm.value.toString(); // Is is necessary?
    return n;
}


// Parse a string out of an element.
function ui_set_element_to_string(e, d)
{
    var celm = document.getElementById(e);
    if (! celm) return false;
    celm.value = d;
    return true;
}



// Parse a float out of an element.
function ui_parse_float_from_element(e, d)
{
    var celm = document.getElementById(e);
    if (! celm) return d;
    var n = parseFloat(celm.value);
    if (isNaN(n)) { alert("float parse error!"); return d; }
    return n;
}


function parse_ciphertext_into_public_key(origin, public_key)
{
    var t = 0;
    var c = 0;
    var lbi = 0;
    var imax = origin.length;
    var asfloat = "";
    
    for (var i = 0; i < imax + 1 && c < 4; ++i)
    {
        if (origin[i] == " " || 
            origin[i] == "\r" || 
            origin[i] == "\n" ||
            i == imax)
        { 
            if (lbi)
            {
                //alert("c = " + c + " -> " + asfloat);
                
                var n = parseFloat(asfloat);
                if (isNaN(n)) { alert("PARSE ERROR!"); return 0; }
                
                if (c == 0)
                {
                    public_key.m_axes.m_xmin = n;
                }
                
                else if (c == 1)
                {
                    public_key.m_axes.m_xmax = n;
                }
                
                else if (c == 2)
                {
                    public_key.m_axes.m_ymin = n;
                }
                
                else if (c == 3)
                {
                    public_key.m_axes.m_ymax = n;
                }
                
                else
                {
                    alert("PARSE ERROR!");
                    return 0;
                }
                
                asfloat = "";
                t = i;
                ++c;

                lbi = 0;
            }
        }

        else
        {
            asfloat = asfloat + origin[i];
            ++lbi;
        }
    }
    
    if (c != 4) { alert("PARSE ERROR!"); return 0; }

    return t;
}


function hexbytes_to_string(origin, offset)
{
    var pstring = "";
    var lookup = "0123456789ABCDEF";
    var imax = origin.length;
    
    for (var i = offset + 1; i < imax; ++i)
    {
        var high_nibble = lookup.indexOf(origin[i - 1]);
        var low_nibble = lookup.indexOf(origin[i]);
        
        if (high_nibble > -1 && low_nibble > -1)
        {
            var c = high_nibble * 16 + low_nibble;
            pstring = pstring + String.fromCharCode(c);
            ++i;
        }
    }
    
    return pstring;
}


function string_to_hexbytes(origin, offset)
{
    var hexbytes = "";
    var lookup = "0123456789ABCDEF";
    var imax = origin.length;
    

    
    for (var i = offset; i < imax; i++)
    {
        var c = origin.charCodeAt(i);
        
        if (c > 255) 
        {
            alert("CHAR RANGE ERROR: " + c); 
            return null;
        }
        
        var low_nibble = c & 0x0F;
        var high_nibble = (c & 0xF0) >> 4;
        
        hexbytes = hexbytes + lookup[high_nibble];
        hexbytes = hexbytes + lookup[low_nibble];
        
        hexbytes = hexbytes + " ";
    }
    
    return hexbytes;
}
